import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

/**This is a text field that lets you enter an integer*/

public class Parameter {
    int x,y,w;
    ListenSquare MAIN,TEXT;
    boolean ACTIVE;
    Color COLOR;
    String S;

    public Parameter(int xx,int yy,int ww,String s) {
	this.x=xx;
	this.y=yy;
	this.w=ww;
	this.S=s;
	TEXT=new ListenSquare(x,y,ww,20);
	COLOR=Color.blue;
	MAIN=new ListenSquare(x,y,ww,20);
	ACTIVE=false;
    }

    public String toString(int a,int b) {
	Integer A=new Integer(a);
	Integer B=new Integer(b);
	String S=A.toString()+"/"+B.toString();
	return(S);
    }

    public void render(Graphics2D g) {	
        drawBG(g);
	g.setColor(Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,12));
	g.drawString(S,x+5,y+15);
    }

    public void render(Graphics2D g,Color C) {	
        drawBG(g,C);
	g.setColor(Color.black);
        g.setFont(new Font("Helvetica",Font.PLAIN,12));
	g.drawString(S,x+5,y+15);
    }

    public void drawBG(Graphics2D g) {
	g.setColor(Color.blue);
	g.fillRect(x,y,w,20);
	g.setColor(Color.white);
	g.drawRect(x,y,w,20);
    }
    public void drawBG(Graphics2D g,Color C) {
	g.setColor(C);
	g.fillRect(x,y,w,20);
	g.setColor(Color.white);
	g.drawRect(x,y,w,20);
    }

    public void activate(Point X) {
	ACTIVE=false;
	if(TEXT.inside(X)==1) ACTIVE=true;
    }
    public int getVal() {
	try {
	  Integer A=new Integer(S);
	  return(A.intValue());
	}
	catch(Exception e) {
	    return 1;
	}
    }

    public long getValLong() {
	Long A=new Long(S);
	return A.longValue();
    }

    /*testing whether the selector is used*/

    public boolean inside(MouseEvent e) {
	MouseData J=MouseData.process(e);
	if(MAIN.inside(J.X)==1) return(true);
	return(false);
    }

    public boolean inside(Point X) {
	if(MAIN.inside(X)==1) return(true);
	return(false);
    }

    public void process(MouseEvent e) {
	MouseData J=MouseData.process(e);
	activate(J.X);
    }

    public boolean processKey(boolean strict,KeyEvent e) {
	if(ACTIVE==false) return(false);
	int n=S.length();

	char ch=e.getKeyChar();

        if(isDigit(ch)==true) {
	    if((strict==true)&&(S.length()<2)) S=S+ch;
	    if((strict==false)&&(S.length()<8)) S=S+ch;
	}

	int val=0;

	val=(int)(ch-' ');
	if(val==0) S=S+" ";


        if (ch==KeyEvent.VK_BACK_SPACE) {
	    if(n>0) S=S.substring(0,n-1);
        }

        if (ch==KeyEvent.VK_DELETE) {
            S="1";
        }

	if(strict==false) {
	  if(ch=='-') {
 	    int k=S.indexOf("-");
	    if(k==-1) S="-"+S;
	    else S=S.substring(1,S.length());
	  }
	}




	if(S.length()>50) S=S.substring(0,n-1);
	return(true);

    }

    public boolean isDigit(char ch) {
        int val=(int)(ch-'0');
        if ((val>=0)&&(val<=9)) {
	    return(true);
	}
	return(false);
    }


}





