import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.math.*;



public class ControlPanelSetup {

    /**This sets up the control panels for the control canvas*/

    public static void main(ControlCanvas C) {
      Color[] C0={new Color(50,150,255),Color.white,Color.white,Color.black,Color.red};

      String[] MainString={"positivity","pos custom","simple root","debug","test"};
      int[] MainState={1,0,0,0};
      C.MAIN=new ControlPanel(C0,MainString,MainState,4);
      C.MAIN.mode=0;

      String[] ExportString={"none","coeffs","approx","export"};
      int[] ExportState={1,0,0};
      C.EXPORT=new ControlPanel(C0,ExportString,ExportState,3);
      C.EXPORT.mode=0;

      String[] Proof1modeString={"posdom variant","posdom MAIN","printN","print","mode"};
      int[] Proof1modeState={1,0,0,0};
      C.PROOF1=new ControlPanel(C0,Proof1modeString,Proof1modeState,4);
      C.PROOF1.mode=0;
      
	  
      String[] StrongString={"weak","strong","posdom mode"};
      int[] StrongState={1,0};
      C.STRONG=new ControlPanel(C0,StrongString,StrongState,2);
      C.STRONG.mode=0;

      String[] PresetString={"Polya","Lemma A221", "Lemma A231", "Lemma A232","Lemma A222","Lemma A222","Lemma A233","Lemma A233","presets"};
      int[] PresetState={1,0,0,0,0,0,0,0};
      C.PRESET=new ControlPanel(C0,PresetString,PresetState,8);
      C.PRESET.mode=0;

      String[] DebugmodeString={"log(m)","coeff matrices","poly1 operations","poly2 operations","1 variable approx","2-variable approx","debug"};
      int[] DebugmodeState={1,0,0,0,0,0};
      C.DEBUG=new ControlPanel(C0,DebugmodeString,DebugmodeState,6);
      C.DEBUG.mode=0;

    }


}



